/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2015 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		߽ǥARMv6-Mѡ
 *
 *  Υ󥯥롼ɥեϡcore_config.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_CORE_INTMODEL_V6M_H
#define TOPPERS_CORE_INTMODEL_V6M_H

#include <sil.h>

/*
 *  åȰ¸Υ֥°
 */
#define TARGET_INHATR  TA_NONKERNEL /* åγߥϥɥ° */

/*
 *  ͥ٥ޥγɽɽѴ
 *
 *  ֥Υե뤫饤󥯥롼ɤΤˡ
 *  CAST
 *   ɽ : TMIN_INTPRI         0  
 *   ɽ :      0         -TMIN_INTPRI
 */
#define EXT_IPM(iipm)   (CAST(PRI,iipm + TMIN_INTPRI))     /* ɽɽ */
#define INT_IPM(ipm)    (CAST(uint8_t, ipm - TMIN_INTPRI)) /* ɽɽ */

/*
 *  ͥ٥ޥNVICͥ٤Ѵ
 */
#define INT_NVIC_PRI(ipm)    (((1 << TBITW_IPRI) - CAST(uint8_t, -(ipm)))  << (8 - TBITW_IPRI))

/*
 *  TIPM_ENAALLʳͥ٥ޥˤɽ
 *
 */
#define IIPM_ENAALL  (-TMIN_INTPRI)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ׵ػߥե饰μ¸Τѿ
 */
extern uint32_t ief;			/* IRQγ׵ĥե饰ξ */
extern uint8_t  ief_systick;	/* SysTickγ׵ĥե饰ξ */

/*
 *  ͥ٥ޥ¸Τѿ
 */
extern uint8_t iipm;		/* ߤγͥ٥ޥ */ 

/*
 *  ͥ٥ޥ¸Τѿkernel_cfg.c
 */
extern const uint32_t iipm_enable_irq_tbl[];
extern const uint8_t iipm_enable_systic_tbl[];

/*
 *  CPUå֤ؤΰܹ
 *
 */
Inline void
x_lock_cpu(void)
{
	set_primask();
	/* ƥ륻ǥ꤬񤭴ǽ */
	ARM_MEMORY_CHANGED;    
}

#define t_lock_cpu()    x_lock_cpu()
#define i_lock_cpu()    x_lock_cpu()

/*
 *  CPUå֤β
 *
 */
Inline void
x_unlock_cpu(void)
{
	/* ƥ륻ǥ꤬񤭴ǽ */
	ARM_MEMORY_CHANGED;
	clear_primask();
}

#define t_unlock_cpu()    x_unlock_cpu()
#define i_unlock_cpu()    x_unlock_cpu()

/*
 *  CPUå֤λ
 */
Inline bool_t
x_sense_lock(void)
{
	return(read_primask() == 0x1u);
}

#define t_sense_lock()    x_sense_lock()
#define i_sense_lock()    x_sense_lock()

/*
 *  chg_ipmͭʳͥ٤ϰϤȽ
 *
 *  TMIN_INTPRIͤˤ餺chg_ipmǤϡ-(1 << TBITW_IPRI)TIPM_ENAALLʡ0
 *  ϰϤǤ뤳ȤȤʥåγĥˡ
 *  ͥ٤Υӥå(TBITW_IPRI) 2 ξϡ-4  0 ǽǤ롥
 *   
 */
#define VALID_INTPRI_CHGIPM(intpri) \
				((-((1 << TBITW_IPRI) - 1) <= (intpri) && (intpri) <= TIPM_ENAALL))

/*
 * ʥǥΡ˳ͥ٥ޥ
 *
 */
Inline void
x_set_ipm(PRI intpri)
{
	uint32_t tmp;
	iipm = INT_IPM(intpri);

	tmp = sil_rew_mem((void *)SYSTIC_CONTROL_STATUS);
	if ((iipm_enable_systic_tbl[iipm] & ief_systick) ==  0x01) {
		tmp |= SYSTIC_TICINT;
	}else{
		tmp &= ~SYSTIC_TICINT;
	}
	sil_wrw_mem((void *)SYSTIC_CONTROL_STATUS, tmp);

	/* ö߶ػ */
	sil_wrw_mem((void *)NVIC_CLRENA0, 0xffffffff);
	sil_wrw_mem((void *)NVIC_SETENA0, (iipm_enable_systic_tbl[iipm] & ief));
}

#define t_set_ipm(intpri)    x_set_ipm(intpri)
#define i_set_ipm(intpri)    x_set_ipm(intpri)

/*
 * ʥǥΡ˳ͥ٥ޥλ
 *
 */
Inline PRI
x_get_ipm(void)
{
	return EXT_IPM(iipm);
}

#define t_get_ipm()    x_get_ipm()
#define i_get_ipm()    x_get_ipm()

/*
 *  ׵ػߥե饰
 */

/*
 *  °ꤵƤ뤫Ƚ̤뤿ѿkernel_cfg.c
 */
extern const uint32_t	bitpat_cfgint[];

/*
 *  ׵ػߥե饰Υå
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤  
 */
Inline bool_t
x_disable_int(INTNO intno)
{
	uint32_t tmp;

	/*
	 *  °ꤵƤʤ
	 */
	if ((bitpat_cfgint[intno >> 5] & (1 << (intno & 0x1f))) == 0x00) {
		return(false);
	}

	if (intno == IRQNO_SYSTICK) {
		tmp = sil_rew_mem((void *)SYSTIC_CONTROL_STATUS);
		tmp &= ~SYSTIC_TICINT;
		sil_wrw_mem((void *)SYSTIC_CONTROL_STATUS, tmp);
		ief_systick &= ~0x01;
	}else {
		tmp = intno - 16;
		sil_wrw_mem((void *)(NVIC_CLRENA0), (1 << (tmp & 0x1f)));
		ief &= ~(1 << (tmp & 0x1f));
	}

	return(true);
}

#define t_disable_int(intno) x_disable_int(intno)
#define i_disable_int(intno) x_disable_int(intno)

/*
 *  ׵ػߥե饰β
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */
Inline bool_t
x_enable_int(INTNO intno)
{
	uint32_t tmp;

	/*
	 *  °ꤵƤʤ
	 */
	if ((bitpat_cfgint[intno >> 5] & (1 << (intno & 0x1f))) == 0x00) {
		return(false);
	}

	if (intno == IRQNO_SYSTICK) {
		ief_systick |= 0x01;
		if ((iipm_enable_systic_tbl[iipm] & ief_systick) ==  0x01) {
			tmp = sil_rew_mem((void *)SYSTIC_CONTROL_STATUS);
			tmp |= SYSTIC_TICINT;;
			sil_wrw_mem((void *)SYSTIC_CONTROL_STATUS, tmp);
		}
	}else {
		tmp = intno - 16;
		ief |= (1 << (tmp & 0x1f));
		if ((iipm_enable_irq_tbl[iipm] & (1 << (tmp & 0x1f))) != 0) {
			sil_wrw_mem((void *)(NVIC_SETENA0), (1 << (tmp & 0x1f)));
		}
	}

	return(true);
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)

/*
 *  PendSVCϥɥcore_support.S
 */
extern void pendsvc_handler(void);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_CORE_INTMODEL_V6M_H */
